const HetznerCloud = require('hcloud-js')
let client
let _ = require('lodash')

class Hetzner {


    constructor(token) {
        client = new HetznerCloud.Client(token)
    }


    getAllServers() {
        return new Promise(function (resolve, reject) {

            client.servers.list().then(function (res) {
                // console.log(res)
                let d = _.values(res.servers);
                resolve(d)

            })
        })


    }


    async deleteServer(id) {
        return new Promise(function (resolve, reject) {

            client.servers.delete(id).then(function (res) {
                resolve(res)
            })
        })
    }

    async removeByIp(ip) {
        try {
            let servers = await this.getAllServers()
            for (let i = 0; i < servers.length; i++) {
                if (ip === servers[i].publicNet.server.publicNet.ipv4.ip)
                    await this.deleteServer(servers[i].id)

            }
        } catch (e) {

        }
        return true

    }


    async getAllFloatingIps() {

    }


    deleteFloatingIp(id) {

    }


    createServer(name) {

        // nuremberg nbg1
        //fsn1

        return new Promise(function (resolve, reject) {
            client.servers.build(name)
                .serverType('cx51-ceph')
                .location('fsn1')
                .image('9541194')
                .sshKey('ffgf')
                .create()
                .then(function (response) {
                    resolve(response)
                })
                .catch(function (error) {
                    // Handle error...
                })
        })

    }


}


module.exports = Hetzner;
